﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            //NativeTypes();

            //GenerateObjects();

            //Generations();

            //GenerationFun();

            object obj = new object();
            WeakReference thing = new WeakReference(obj);

            GC.Collect();

            Console.WriteLine("Noch am leben? {0}", thing.IsAlive);
            Console.ReadLine();

            object obj2 = thing.Target;


            Console.WriteLine("Object is null {0}", obj2 == null);

            Console.ReadLine();
        }

        private static void GenerationFun()
        {
            Console.WriteLine("lets play");
            Console.ReadLine();

            object[] history = new object[1000000];
            Random rnd = new Random();

            while (true)
            {
                history[rnd.Next(history.Length)] = new object();
            }
        }

        private static void Generations()
        {
            myObject obj = new myObject();
            Console.WriteLine(GC.GetGeneration(obj));
            Console.ReadLine();
            GC.Collect();
            Console.WriteLine(GC.GetGeneration(obj));
            Console.ReadLine();
            GC.Collect();
            Console.WriteLine(GC.GetGeneration(obj));
            Console.ReadLine();
            obj = null;
            GC.Collect();
            Console.WriteLine(GC.GetGeneration(obj));
        }

        private static void GenerateObjects()
        {
            int counter = 0;

            while (2*2 < 5)
            {
                new myObject();
                counter++;
                if (counter%1000000 == 0)
                {
                    Console.Write(".");
                }
            }
        }

        private static void NativeTypes()
        {
            for (int i = 0; i < 32000; i++)
            {
                new GcDataTypes();
            }
        }
    }

    internal class myObject
    {
        ~myObject()
        {
            //TODO: Clean up
        }        
    }

    internal class GcDataTypes
    {
        private int data;
        private long _;
        private long __;
        private long ___;
        private long ____;
        private long _____;
        private long ______;
        private long _______;
        private long ________;

        public GcDataTypes()
        {
            unsafe
            {
                fixed (int* ptr = &data)
                {
                    Console.WriteLine((int)ptr);
                }
            }
        }
    }
}
